找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 900|回复: 0

[分享] Add bulged segment (create jumpover)

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:08:23 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
       public static void Jumper()   
    {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;
            Matrix3d ucs = ed.CurrentUserCoordinateSystem;
            Database db = doc.Database;
            PromptEntityResult res = ed.GetEntity(new PromptEntityOptions("Select polyline : "));
            if (res.Status != PromptStatus.OK) return;
            ObjectId id = res.ObjectId;
            Point3d pp = res.PickedPoint;
            // Set break gap
            double gap = 3.0;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                BlockTable bt = (BlockTable)db.BlockTableId.GetObject(OpenMode.ForRead);
                BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
                Entity ent = tr.GetObject(id, OpenMode.ForWrite) as Entity;
                Polyline poly = ent as Polyline;
                if (poly == null) return;
                pp = poly.GetClosestPointTo(pp, false).TransformBy(ucs);
                double par = poly.GetParameterAtPoint(pp);
                double dist = poly.GetDistAtPoint(pp);
                int idx = (int)par;            
                Point3d p1 = poly.GetPointAtDist(dist - gap/2).TransformBy(ucs);
                Point3d p2 = poly.GetPointAtDist(dist + gap/2).TransformBy(ucs);
                poly.AddVertexAt(idx+1, new Point2d(p1.X, p1.Y), 1, 0, 0);
                poly.AddVertexAt(idx+2, new Point2d(p2.X, p2.Y), 0, 0, 0);            
                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:30 , Processed in 0.164940 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表